<template>
  <div>
    <PreviewProduct />
  </div>
</template>

<script lang="ts">
//@ts-nocheck

import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import axios from "axios";
import { $axios } from "~/utils/axios";
import { api } from "~/common/constaint";
import { resources } from "~/interfaces/api";
import { apiErrorHandler, redirectPage } from "~/utils/apiHanlers";
import language from "~/locales/language-product.json";
import { NuxtAxiosInstance } from "@nuxtjs/axios";
@Component({
  layout: "user",
  components: {
    PreviewProduct: () =>
      import("@/components/Seller/Products/PreviewProduct/index.vue"),
  },
})
export default class PreviewProductsPage extends Vue {
  head() {
    return {
      title:
        this.$store.state.setting.siteInfo &&
        this.$store.state.setting.siteInfo.webTitle,
      link: [
        {
          rel: "icon",
          type: "image/x-icon",
          href: `${api}/${
            this.$store?.state?.setting?.siteInfo?.logo?.imageUrl || ""
          }`,
        },
      ],
    };
  }

  fetchOnServer = true;

  asyncData({
    params,
    $axios,
    store,
    redirect,
    route,
    authenticated,
    req,
  }: {
    params: any;
    $axios: any;
    store: any;
    redirect: any;
    route: any;
    authenticated: any;
    req: any;
  }) {
    return new Promise(async (resolve, reject) => {
      try {
        const slug = route.params.slug;
        store.commit("product/setLoadingPaypal", true);
        const proms = [
          //   $axios.$get(`${api()}/${resources.StoreBuyer}/setting/${slug}`),
          //   $axios.$get(`${api()}/${resources.PaymentBuyer}/list/${slug}`),
          $axios.$get(`${api}/product/product-detail/${slug}`),
          // $axios.$get(
          // 	`${api()}/${resources.Product}/review/${
          // 		params.slug
          // 	}`
          // ),
          // $axios.$get(
          // 	`${api()}/${resources.Promotion}/promotion-detail`
          // ),
        ];
        const [
          //   responseSetting,
          //   responseListPayment,
          response,
          // responseListReview,
          // responsePromotion,
        ] = await Promise.all(proms);

        const product = {
          ...response.data,
          listVariantOptionId:
            response.data.listVariant[0].listVariantOptionId.map(
              (variant: any) => ({
                selected: 0,
                name: variant.name,
                values: variant.values,
                _id: variant._id,
                id: variant.id,
              })
            ),
          imageIds: response.data.listImageId,
        };
        if (response?.data?.listVariant?.length) {
          response.data.priceProductSrr = response.data.listVariant[0].price;
        }
        // if (responsePromotion?.data) {
        // 	store.commit(
        // 		"promotion/setPromotion",
        // 		responsePromotion.data
        // 	);
        // }
        let productLanguage = {};
        if (response?.data?.language) {
          const { language: languageResponse } = response.data;
          productLanguage = language[languageResponse] || language["EN"];
        }
        // store.commit("cart/setListPayment", responseListPayment.data);
        // store.commit("cart/setPublicKey", responseListPayment.data);
        store.commit("product/setProduct", product);
        store.commit("product/setLanguage", productLanguage);
        // store.commit(
        // 	"product/setListReviewProduct",
        // 	responseListReview.data.data
        // );
        // const setting = {
        //   ...responseSetting.data,
        //   logo: responseSetting.data?.logo?.imageUrl || "",
        // };
        // const findIndexPaypal = responseListPayment.data.findIndex(
        // 	(payment: any) => payment.type === "paypal"
        // );
        // store.commit("setting/setSiteInfo", responseSetting.data);
        resolve({
          product: product || {},
          // listReviewProduct: responseListReview.data.data,
          //   setting,
          publicKeyPaypal: "",
          // promotion: responsePromotion.data,
          language: productLanguage,
        });
      } catch (error) {
        // if (!authenticated) {
        redirect(`/error`);
        // }
        // apiErrorHandler(error, this);
        resolve({});
      }
    });
  }
}
</script>
